diff -arcN emacs-18.55/src/dispnew.c nemacs-3.3.2/src/dispnew.c
*** emacs-18.55/src/dispnew.c	Sun Aug 13 01:30:37 1989
--- nemacs-3.3.2/src/dispnew.c	Wed Jun  6 03:18:18 1990
***************
*** 1,3 ****
--- 1,9 ----
+ /* 87.5.28  modified by K.Handa */
+ /* 89.3.23  modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.11.24 modified for attribute of characters by K.Handa */
+ /* 90.2.27  modified for Nemacs Ver.3.3 by K.Handa
+ 	Attribute related bugs are fixed in update_line. */
+ 
  /* Newly written part of redisplay code.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 60,65 ****
--- 66,74 ----
  #include "buffer.h"
  #include "window.h"
  #include "commands.h"
+ #ifdef NEMACS  /* 89.2.9  by K.Handa */
+ #include "kanji.h"
+ #endif
  
  #define max(a, b) ((a) > (b) ? (a) : (b))
  #define min(a, b) ((a) < (b) ? (a) : (b))
***************
*** 71,76 ****
--- 80,92 ----
  #define PENDING_OUTPUT_COUNT(FILE) ((FILE)->_ptr - (FILE)->_base)
  #endif
  
+ /* patch for attribute of characters  by K.Handa 89.11.21 */
+ /* Global variable to notify writechars (in x11term.c) the current address
+    of corresponding attribute.
+    What a smart solution! :-( :-( :-( */
+ char *attribute_p;
+ /* end of patch */
+ 
  /* Nonzero means do not assume anything about current
   contents of actual terminal screen */
  
***************
*** 324,330 ****
--- 340,354 ----
        hpos -= line->length;
        line->length += hpos;
        while (--hpos >= 0)
+ /* patch for attribute by K.Handa  89.11.21 */
+ /* original line is
  	*p++ = ' ';
+    and new lines are */
+ 	{
+ 	  line->attribute[p - line->body] = 0;
+ 	  *p++ = ' ';
+ 	}
+ /* end of patch */
      }
  
    DesiredScreen[vpos + 1] = line;
***************
*** 402,407 ****
--- 426,433 ----
  	  if (start > 0)
  	    {
  	      bcopy (l2->body, l1->body, start);
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	      bcopy (l2->attribute, l1->attribute, start);
  	      if (l1->length < start && l1->length < l2->length)
  		l1->length = min (start, l2->length);
  	    }
***************
*** 408,414 ****
--- 434,449 ----
  	  if (l2->length > end && l1->length < l2->length)
  	    {
  	      while (l1->length < end)
+ /* patch for attribute by K.Handa  89.11.24 */
+ /* original line is
  		l1->body[l1->length++] = ' ';
+    and new lines are */
+  		{
+ 		  l1->attribute[l1->length] = 0;
+ 		  l1->body[l1->length++] = ' ';
+ 		}
+ 	      bcopy (l2->attribute+end, l1->attribute+end, l2->length-end);
+ /* end of patch */
  	      bcopy (l2->body + end, l1->body + end, l2->length - end);
  	      l1->length = l2->length;
  	    }
***************
*** 444,450 ****
--- 479,494 ----
  	      fin = l2->length;
  	      if (fin > end) fin = end;
  	      while (l1->length < start)
+ /* patch for attribute by K.Handa  89.11.24, 90.2.27 */
+ /* original line is
  		l1->body[l1->length++] = ' ';
+    and new lines are */
+ 		{
+ 		  l1->attribute[l1->length] = 0;
+ 		  l1->body[l1->length++] = ' ';
+ 		}
+ 	      bcopy (l2->attribute+start, l1->attribute+start, fin-start);
+ /* end of patch */
  	      bcopy (l2->body + start, l1->body + start, fin - start);
  	      l1->length = fin;
  	    }
***************
*** 522,527 ****
--- 566,573 ----
    XFASTINT (w->last_modified) = bf_modified;
  
    reassert_line_highlight (0, cursY);
+ /* patch for attribute by K.Handa  89.11.24 */
+   attribute_p = p->attribute + hpos;
    write_chars (p->body + hpos, 1);
    fflush (stdout);
    ++cursX;
***************
*** 788,796 ****
--- 834,850 ----
       int vpos;
  {
    register char *obody, *nbody, *op1, *op2, *np1;
+ /* patch for attribute  by K.Handa 89.11.25 */
+   register char *oattr, *nattr;
    int tem;
    int osp, nsp, m1, m2, olen, nlen;
    int save;
+ #ifdef NEMACS  /* 87.6.9, 89.2.9  by K.Handa*/
+   int flag = 0;
+ 
+ /* to notify write_chars () that the line has Japanese codes */
+   current_kanji_flag = new->kanji_flag;
+ #endif
  
    if (old == new)
      return;
***************
*** 814,824 ****
--- 868,884 ----
      {
        obody = old -> body;
        olen = old->length;
+ /* patch for attribute  by K.Handa 89.11.25 */
+       oattr = old -> attribute;
        if (! old->highlighted)
  	{
  	  /* Note obody[-1] is old->physical, which is always 0 or 1.  */
  	  if (!must_write_spaces)
+ /* patch for attribute  by K.Handa 89.11.25 */
+ /* original line is
  	    while (obody[olen - 1] == ' ')
+    and new line is */
+ 	    while (obody[olen - 1] == ' ' && oattr[olen - 1] == 0)
  	      olen--;
  	}
        else
***************
*** 839,844 ****
--- 899,906 ----
  
    nbody = new -> body;
    nlen = new->length;
+ /* patch for attribute  by K.Handa 89.11.25 */
+   nattr = new -> attribute;
  
    /* Pretend trailing spaces are not there at all,
       unless for one reason or another we must write all spaces.  */
***************
*** 847,853 ****
--- 909,919 ----
    if (! new->highlighted)
      {
        if (!must_write_spaces)
+ /* patch for attribute  by K.Handa 89.11.25, 90.2.27 */
+ /* original line is
  	while (nbody[nlen - 1] == ' ')
+    and new line is */
+ 	while (nbody[nlen - 1] == ' ' && nattr[nlen - 1] == 0)
  	  nlen--;
      }
    else
***************
*** 864,883 ****
--- 930,980 ----
      {
        int i,j;
  
+ #ifdef NEMACS  /* 89.2.27  by K.Handa */
+       /* 89.2.27  by K.Handa suggested by hoshino@star.tt.kubota.junet */
+       int kolen = 0, knlen = 0;
+ #endif
        for (i = 0; i < nlen; i++)
  	{
+ #ifdef NEMACS  /* 89.2.27  by K.Handa */
+ 	  if (i >= olen || nbody[i] != obody[i]
+ /* patch for attribute  by K.Handa 89.11.25 */
+ 	      || nattr[i] != oattr[i]
+ 	      || (nbody[i] & 0x80 && nbody[i+1] != obody[i+1]))
+ #else
  	  if (i >= olen || nbody[i] != obody[i])
+ #endif
  	    {
  	      /* We found a non-matching char.  */
  	      topos (vpos, i);
+ #ifdef NEMACS  /* 89.2.27  by K.Handa */
+ 	      j = i;
+ 	      do {
+ 		if (nbody[j] & 0x80) knlen++; else knlen = 0;
+ 		if (j < olen && obody[j] & 0x80) kolen++; else kolen = 0;
+ 		j++;
+ 	      } while (j < nlen &&
+ 		       (j >= olen || nbody[j] != obody[j]
+ /* patch for attribute  by K.Handa 89.11.25 */
+ 			|| nattr[j] != oattr[j]
+ 			|| knlen & 1 || kolen & 1));
+ 	      j -= i;
+ #else  /* not NEMACS */
  	      for (j = 1; (i + j < nlen &&
  			   (i + j >= olen || nbody[i+j] != obody[i+j]));
  		   j++);
+ #endif  /* not NEMACS */
  	      /* Output this run of non-matching chars.  */ 
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	      attribute_p = nattr + i;
  	      write_chars (nbody + i, j);
  	      i += j - 1;
  	      /* Now find the next non-match.  */
  	    }
+ #ifdef NEMACS  /* 89.2.27  by K.Handa */
+ 	  else
+ 	    if (nbody[i] & 0x80 && i < nlen) i++;
+ #endif
  	}
        /* Clear the rest of the line, or the non-clear part of it.  */
        if (olen > nlen)
***************
*** 895,900 ****
--- 992,999 ----
        if (nlen > nsp)
  	{
  	  topos (vpos, nsp);
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	  attribute_p = nattr + nsp;
  	  write_chars (nbody + nsp, nlen - nsp);
  	}
        return;
***************
*** 905,918 ****
--- 1004,1029 ----
    nbody[nlen] = 0;
  
    /* Compute number of leading blanks in old and new contents.  */
+ /* patch for attribute by K.Handa  89.11.24 */
+ /* original line is
    osp = count_blanks (obody);
+    and new line is */
+   osp = count_blanks2 (obody, oattr);
    if (!new->highlighted)
+ /* patch for attribute by K.Handa  89.11.24 */
+ /* original line is
      nsp = count_blanks (nbody);
+    and new line is */
+     nsp = count_blanks2 (nbody, nattr);
    else
      nsp = 0;
  
    /* Compute number of matching chars starting with first nonblank.  */
+ /* patch for attribute by K.Handa  89.11.24 */
+ /* original line is
    m1 = count_match (obody + osp, nbody + nsp);
+    and new line is */
+   m1 = count_match2 (obody + osp, oattr + osp, nbody + nsp, nattr + nsp);
  
    /* Spaces in new match implicit space past the end of old.  */
    /* A bug causing this to be a no-op was fixed in 18.29.  */
***************
*** 919,925 ****
--- 1030,1040 ----
    if (!must_write_spaces && osp + m1 == olen)
      {
        np1 = nbody + nsp;
+ /* patch for attribute by K.Handa  89.11.24 */
+ /* original line is
        while (np1[m1] == ' ')
+    and new line is */
+       while (np1[m1] == ' ' && nattr[nsp+m1] == 0)
  	m1++;
      }
  
***************
*** 933,943 ****
--- 1048,1067 ----
    op1 = obody + olen;
    np1 = nbody + nlen;
    op2 = op1 + m1 - min (olen - osp, nlen - nsp);
+ /* patch for attribute by K.Handa  89.11.24 */
+ /* original line is
    while (op1 > op2 && op1[-1] == np1[-1])
+    and new line is */
+   while (op1 > op2 && op1[-1] == np1[-1] && oattr[op1-obody-1] == nattr[np1-nbody-1])
      {
        op1--;
        np1--;
+ #ifdef NEMACS  /* 87.5.28, 89.2.27  by K.Handa  */
+       if (EUC_P((unsigned char)*op1) && *(--op1) != *(--np1)) {
+ 	op1 += 2; break;
      }
+ #endif
+     }
    m2 = obody + olen - op1;
  
    /* Put correct value back in nbody[nlen].
***************
*** 999,1004 ****
--- 1123,1130 ----
  	     going to be "at the margin" after the text is done) */
  	  if (nlen == screen_width)
  	    olen = 0;
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	  attribute_p = new->attribute + nsp + m1;
  	  write_chars (nbody + nsp + m1, nlen - tem);
  #ifdef obsolete
  /* the following code loses disastrously if tem == nlen.
***************
*** 1011,1033 ****
--- 1137,1188 ----
  	  if (nlen == screen_width && fast_clear_end_of_line && olen > nlen)
  	    {
  	      /* m2 must be zero, and tem must equal nsp + m1 */
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	      attribute_p = nattr + tem;
  	      write_chars (nbody + tem, nlen - tem - 1);
  	      clear_end_of_line (olen);
  	      olen = 0;		/* Don't let it be cleared again later */
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	      attribute_p = nattr + nlen - 1;
  	      write_chars (nbody + nlen - 1, 1);
  	    }
  	  else
+ /* patch for attribute by K.Handa  89.11.24 */
+ /* original line is
  	    write_chars (nbody + nsp + m1, nlen - tem);
+    and new lines are */
+ 	    {
+ 	      attribute_p = nattr + nsp + m1;
+ 	      write_chars (nbody + nsp + m1, nlen - tem);
+ 	    }
+ /* end of patch */
  #endif
  	}
        else if (nlen > olen)
  	{
+ #ifdef NEMACS  /* 89.2.27  by K.Handa  */
+ 	  int flag = 0, len = olen - tem;
+ 	  char *i = nbody + nsp + m1;
+ 	  
+ 	  while(len--) {
+ 	    if (EUC_P((unsigned char)*i)) flag++; else flag = 0;
+ 	    i++;
+ 	  }
+ 	  if (flag & 1) olen--;
+ #endif  /* NEMACS */
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	  attribute_p = nattr + nsp + m1;
  	  write_chars (nbody + nsp + m1, olen - tem);
+ #ifdef NEMACS  /* 89.2.27  by K.Handa  */
+ 	  if (flag & 1) delete_chars (1);
+ #endif
  	  insert_chars (nbody + nsp + m1 + olen - tem, nlen - olen);
  	  olen = nlen;
  	}
        else if (olen > nlen)
  	{
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	  attribute_p = nattr + nsp + m1;
  	  write_chars (nbody + nsp + m1, nlen - tem);
  	  delete_chars (olen - nlen);
  	  olen = nlen;
***************
*** 1056,1064 ****
--- 1211,1254 ----
  {
    register char *p1 = str1;
    register char *p2 = str2;
+ #ifdef NEMACS  /* 87.5.29, 89.2.27  by K.Handa */
+   register char c;
+   while ((c = *p1++) == *p2++)
+     if (EUC_P((unsigned char)c) && *p1++ != *p2++) {
+       p1--; break;
+     }
+ #else  /* not NEMACS */
    while (*p1++ == *p2++);
+ #endif  /* not NEMACS */
+   return p1 - str1 - 1;
+ }
+ 
+ /* patch for attribute by K.Handa  89.11.24 */
+ count_blanks2 (str, attr)
+      char *str, *attr;
+ {
+   register char *p = str;
+   while (*str++ == ' ' && *attr++ == 0);
+   return str - p - 1;
+ }
+ 
+ count_match2 (str1, attr1, str2, attr2)
+      char *str1, *attr1, *str2, *attr2;
+ {
+   register char *p1 = str1;
+   register char *p2 = str2;
+ #ifdef NEMACS  /* 87.5.29, 89.2.27  by K.Handa */
+   register char c;
+   while ((c = *p1++) == *p2++ && *attr1++ == *attr2)
+     if (EUC_P((unsigned char)c) && *p1++ != *p2++) {
+       p1--; break;
+     }
+ #else  /* not NEMACS */
+   while (*p1++ == *p2++ && *attr1++ == *attr2++);
+ #endif  /* not NEMACS */
    return p1 - str1 - 1;
  }
+ /* end of patch */
  
  DEFUN ("open-termscript", Fopen_termscript, Sopen_termscript,
    1, 1, "FOpen termscript file: ",
diff -arcN emacs-18.55/src/editfns.c nemacs-3.3.2/src/editfns.c
*** emacs-18.55/src/editfns.c	Sat Jul 22 03:21:32 1989
--- nemacs-3.3.2/src/editfns.c	Wed Jun  6 03:18:18 1990
***************
*** 452,462 ****
--- 452,476 ----
    return build_string (tem);
  }
  
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+ extern int InsCStr (), insert_before_markers (), insert_after_markers ();
+ /* end of patch */
+ 
  DEFUN ("insert", Finsert, Sinsert, 0, MANY, 0,
    "Any number of args, strings or chars.  Insert them after point, moving point forward.")
    (nargs, args)
       int nargs;
       register Lisp_Object *args;
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+ {
+   insert_with_specified_function (InsCStr, nargs, args);
+   return Qnil;
+ }
+ 
+ insert_with_specified_function (func, nargs, args)
+      int (*func)(), nargs;
+      register Lisp_Object *args;
+ /* end of patch */
  {
    register int argnum;
    register Lisp_Object tem;
***************
*** 469,479 ****
--- 483,501 ----
        if (XTYPE (tem) == Lisp_Int)
  	{
  	  str[0] = XINT (tem);
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+ /* original line is
  	  InsCStr (str, 1);
+    and new line is */
+ 	  (*func) (str, 1);
  	}
        else if (XTYPE (tem) == Lisp_String)
  	{
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+ /* original line is
  	  InsCStr (XSTRING (tem)->data, XSTRING (tem)->size);
+    and new line is */
+ 	  (*func) (XSTRING (tem)->data, XSTRING (tem)->size);
  	}
        else
  	{
***************
*** 481,487 ****
  	  goto retry;
  	}
      }
!   return Qnil;
  }
  
  DEFUN ("insert-before-markers", Finsert_before_markers, Sinsert_before_markers, 0, MANY, 0,
--- 503,510 ----
  	  goto retry;
  	}
      }
! /* patch for point_type_marker by K.Handa 89.11.30 */
! /*  return Qnil; */
  }
  
  DEFUN ("insert-before-markers", Finsert_before_markers, Sinsert_before_markers, 0, MANY, 0,
***************
*** 491,496 ****
--- 514,521 ----
    (nargs, args)
       int nargs;
       register Lisp_Object *args;
+ /* patch for point_type_marker by K.Handa  89.11.30 */
+ /* original lines are
  {
    register int argnum;
    register Lisp_Object tem;
***************
*** 517,522 ****
--- 542,567 ----
      }
    return Qnil;
  }
+    and new lines are */
+ {
+   insert_with_specified_function (insert_before_markers, nargs, args);
+   return Qnil;
+ }
+ /* end of patch */
+ 
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+ DEFUN ("insert-after-markers", Finsert_after_markers, Sinsert_after_markers, 0, MANY, 0,
+   "Any number of args, strings or chars.  Insert them after point,\n\
+ moving point forward.  Also, any markers of point_type pointing at\n\
+ the insertion point get relocated to point before the newly inserted text.")
+   (nargs, args)
+      int nargs;
+      register Lisp_Object *args;
+ {
+   insert_with_specified_function (insert_after_markers, nargs, args);
+   return Qnil;
+ }
+ /* end of patch */
  
  DEFUN ("insert-char", Finsert_char, Sinsert_char, 2, 2, 0,
    "Insert COUNT (second arg) copies of CHAR (first arg).\n\
***************
*** 1014,1019 ****
--- 1059,1067 ----
    defsubr (&Schar_after);
    defsubr (&Sinsert);
    defsubr (&Sinsert_before_markers);
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+   defsubr (&Sinsert_after_markers);
+ /* end of patch */
    defsubr (&Sinsert_char);
  
    defsubr (&Suser_login_name);
diff -arcN emacs-18.55/src/emacs.c nemacs-3.3.2/src/emacs.c
*** emacs-18.55/src/emacs.c	Tue Mar 14 06:41:29 1989
--- nemacs-3.3.2/src/emacs.c	Wed Jun  6 03:18:06 1990
***************
*** 1,3 ****
--- 1,7 ----
+ /* 87.6.9   modified by K.Handa */
+ /* 88.1.10  modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.6.20  modified for Nemacs Ver.2.1 by K.Handa */
+ 
  /* Fully extensible Emacs, running on Unix, intended for GNU.
     Copyright (C) 1985, 1986, 1987 Free Software Foundation, Inc.
  
***************
*** 325,330 ****
--- 329,337 ----
  
    if (!initialized)
      {
+ #ifdef NEMACS	/* 89.7.26  by K.Handa */
+       init_kanji ();
+ #endif
        init_alloc_once ();
        init_obarray ();
        init_eval_once ();
***************
*** 431,436 ****
--- 438,456 ----
        SYMS_MACHINE;
  #endif
  
+ #ifdef NEMACS  /* 87.6.8  by K.Handa */
+       syms_of_kanji ();
+ #ifdef EGG
+ #ifdef WNN3
+       syms_of_wnn ();
+ #else  /* not WNN3 */
+ #ifdef WNN4V3
+       syms_of_wnn ();
+ #endif  /* WNN4V3 */
+ #endif  /* not WNN3 */
+ #endif  /* EGG */
+ #endif  /* NEMACS */
+ 
        keys_of_casefiddle ();
        keys_of_cmds ();
        keys_of_buffer ();
***************
*** 494,499 ****
--- 514,528 ----
  	      NULL (answer)))
  	return Qnil;
  #endif /* subprocesses */
+ #ifdef EGG
+ #ifdef WNN3
+       wnn_exit();
+ #else  /* not WNN3 */
+ #ifdef WNN4V3
+       wnn_exit();
+ #endif
+ #endif /* not WNN3 */
+ #endif /* EGG */
      }
  
  #ifdef subprocesses
diff -arcN emacs-18.55/src/fileio.c nemacs-3.3.2/src/fileio.c
*** emacs-18.55/src/fileio.c	Wed Jul  5 10:00:25 1989
--- nemacs-3.3.2/src/fileio.c	Wed Jun  6 03:18:19 1990
***************
*** 1,3 ****
--- 1,11 ----
+ /* 87.4.29  modified by K.Handa */
+ /* 87.12.10 modified for Nemacs Ver.2.0 by K.Handa */
+ /* 89.3.23  modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.9.12  modified for Nemacs Ver.3.2 by S.Tomura */
+ /* 89.12.29 modified for Nemacs Ver.3.3.1 by S.Tomura */
+ /* 90.2.28  modified for Nemacs Ver.3.3.1 by abe@sunrise.hallab.co.jp
+ 	do GCPRO (filename) before Ffuncall */
+ 
  /* File IO for GNU Emacs.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 64,69 ****
--- 72,81 ----
  #include <netio.h>
  #include <errnet.h>
  #endif
+ #ifdef NEMACS  /* 87.6.8  by K.Handa */
+ #include "kanji.h"
+ #include "syntax.h"		/* 89.11.17  by K.Handa */
+ #endif
  
  #define min(a, b) ((a) < (b) ? (a) : (b))
  #define max(a, b) ((a) > (b) ? (a) : (b))
***************
*** 1460,1465 ****
--- 1472,1482 ----
    close (XFASTINT (fd));
  }
  
+ #ifdef NEMACS /* 89.9.1 by S.Tomura */
+ Lisp_Object Qfind_kanji_file_input_code;
+ Lisp_Object Qinvoke_find_kanji_file_input_code;
+ #endif
+ 
  DEFUN ("insert-file-contents", Finsert_file_contents, Sinsert_file_contents,
    1, 2, 0,
    "Insert contents of file FILENAME after point.\n\
***************
*** 1476,1481 ****
--- 1493,1501 ----
    register int size = 0;
    register int i;
    int count = specpdl_ptr - specpdl;
+ #ifdef NEMACS /* 89.1.10  by K.Handa */
+   unsigned char *saved_p;
+ #endif
  
    if (!NULL (bf_cur->read_only))
      Fbarf_if_buffer_read_only();
***************
*** 1514,1519 ****
--- 1534,1543 ----
    if (bf_gap < st.st_size)
      make_gap (st.st_size);
      
+ #ifdef NEMACS /* 88.1.10  by K.Handa */
+   saved_p = bf_p1 + bf_s1 + 1;
+ #endif
+ 
    size = 0;
    while ((i = read (fd, bf_p1 + bf_s1 + 1, st.st_size - size)) > 0)
      {
***************
*** 1523,1528 ****
--- 1547,1590 ----
        size += i;
      }
  
+ #ifdef NEMACS /* 89.9.1  by S. Tomura */
+   if (!NULL (bf_cur->kanji_flag) &&
+       EQ(Fboundp (Qfind_kanji_file_input_code), Qt)) {
+     Lisp_Object code, args[5];
+     int saved_s1 = bf_s1;
+     struct gcpro gcpro1;	/* 90.2.28  patch by S.Abe */
+     code = Qnil; 
+     args[0] = Qinvoke_find_kanji_file_input_code;
+     args[1] = filename ;
+     args[2] = visit ;
+     args[3] = make_number ( point );
+     args[4] = make_number ( point + size );
+     GCPRO1 (filename);		/* 90.2.28  patch by S.Abe */
+     code = Ffuncall (5, args);
+     UNGCPRO;			/* 90.2.28  patch by S.Abe */
+     if (bf_s1 != saved_s1) move_gap(saved_s1);
+     if (XTYPE(code) != Lisp_Int) code = make_number ( NOCONV );
+ 
+     switch (XFASTINT (code)) {
+     case JIS:
+       {
+ 	int reduced_size =
+ 	  size - convert_kanji_code(size, saved_p, saved_p, JIS, EUC);
+ 	bf_s1 -= reduced_size;
+ 	bf_gap += reduced_size;
+ 	bf_p2 += reduced_size;
+ 	size -= reduced_size;
+       }
+       break;
+     case Shift_JIS:
+       convert_kanji_code(size, saved_p, saved_p, Shift_JIS, EUC);
+       break;
+     default:			/* EUC */
+       break;
+     }
+   }
+ #endif /* NEMACS */
+ 
    if (size > 0)
      bf_modified++;
    record_insert (point, size);
***************
*** 1561,1566 ****
--- 1623,1633 ----
    return Fcons (filename, Fcons (make_number (size), Qnil));
  }
  
+ #ifdef NEMACS /* 89.9.1 by S.Tomura*/
+ Lisp_Object Qfind_kanji_file_output_code;
+ Lisp_Object Qinvoke_find_kanji_file_output_code;
+ #endif
+ 
  DEFUN ("write-region", Fwrite_region, Swrite_region, 3, 5,
    "r\nFWrite region to file: ",
    "Write current region into specified file.\n\
***************
*** 1696,1701 ****
--- 1763,1792 ----
    failure = 0;
    if (XINT (start) != XINT (end))
      {
+ #ifdef NEMACS /* 89.9.1, 89.12.29  by S. Tomura */
+       Lisp_Object savep = Qnil;
+       Lisp_Object kanji_fileio_code;
+   if (!NULL (bf_cur->kanji_flag) &&
+       EQ(Fboundp(Qfind_kanji_file_output_code),Qt)) {
+     Lisp_Object code, args[6];
+     struct gcpro gcpro1;	/* patch by S.Abe */
+     code = Qnil; 
+     args[0] = Qinvoke_find_kanji_file_output_code;
+     args[1] = start;
+     args[2] = end; 
+     args[3] = filename;
+     args[4] = append;
+     args[5] = visit;
+     GCPRO1 (filename);		/* patch by S.Abe */
+     code = Ffuncall (6, args);
+     UNGCPRO;			/* patch by S.Abe */
+     if (XTYPE(code) != Lisp_Int) code = make_number ( NOCONV );
+     savep = Qt;
+     kanji_fileio_code = bf_cur->kanji_fileio_code;
+     bf_cur->kanji_fileio_code = code;
+   }
+ #endif /* NEMACS */
+ 
        if (XINT (start) - 1 < bf_s1)
  	{
  	  register int end1 = XINT (end);
***************
*** 1710,1715 ****
--- 1801,1810 ----
  	  tem = max (tem, bf_s1 + 1);
  	  failure = 0 > e_write (fd, &CharAt (tem), XINT (end) - tem);
  	}
+ #ifdef NEMACS /* 89.9.3 by S. Tomura */
+       if (EQ(savep, Qt)) 
+ 	bf_cur->kanji_fileio_code = kanji_fileio_code;
+ #endif /* NEMACS */
      }
  
  #ifndef USG
***************
*** 1796,1802 ****
--- 1891,2005 ----
       int fd;
       register char *addr;
       register int len;
+ #ifdef NEMACS /* 88.2.29, 89.2.27  by K.Handa */
+ /* Big change for handling selective_display. */
  {
+   unsigned char **buf;
+   int maxidx = 0;
+   int result = 0, i, idx = 0;
+   register unsigned char *p = (unsigned char *)addr;
+   register unsigned char *pend = (unsigned char *)addr + len;
+   unsigned char *buf2;  /* 89.2.27  by K.Handa */
+ 
+   if (EQ (bf_cur->selective_display, Qt)) {
+     if ((buf = (unsigned char **)malloc((maxidx = 256) * sizeof p))
+ 	== (unsigned char **)0)
+       memory_full ();
+     while (p < pend) {
+       if (*p == '\015') {
+ 	*p = '\n';
+ 	buf[idx++] = p;
+ 	if (idx >= maxidx) {
+ 	  maxidx += 256;
+ 	  if ((buf = (unsigned char **)realloc(buf, (maxidx * sizeof p)))
+ 	      == (unsigned char **)0)
+ 	    memory_full();
+ 	}
+       }
+       p++;
+     }
+   }
+ 
+ /* 89.2.27, 89.11.17  patch by K.Handa */
+   if (!NULL (bf_cur->kanji_flag)
+       && !NULL (bf_cur->kanji_fileio_code)
+       && XFASTINT (bf_cur->kanji_fileio_code) != EUC
+       && XFASTINT (bf_cur->kanji_fileio_code) != NOCONV) {
+ 				/* We needs code conversion. */
+     unsigned char *q = (unsigned char *)kanji_work_area;
+     unsigned char *qend = q + KANJI_WORK_SIZE - 9;
+     unsigned char c1, c2;
+     int kflag = 0;
+ 
+     p = (unsigned char *)addr;
+     pend--;
+     switch (XFASTINT(bf_cur->kanji_fileio_code)) {
+     case JIS:
+       while (p < pend) {
+ 	if (q >= qend) {
+ 	  result = (write(fd, kanji_work_area, (char *)q - kanji_work_area)
+ 		    == (char *)q - kanji_work_area) ? 0 : -1;
+ 	  if (result < 0) break;
+ 	  q = (unsigned char *)kanji_work_area;
+ 	}
+ 	if (kflag) {
+ 	  if (JCODEP(p)) {
+ 	    *q++ = *p++ & 0x7f; *q++ = *p++ & 0x7f;
+ 	  } else {
+ 	    *q++ = ESC_CODE; *q++ = '('; *q++ = to_ascii_fileio;
+ 	    *q++ = *p++;
+ 	    kflag = 0;
+ 	  }
+ 	} else {
+ 	  if (JCODEP(p)) {
+ 	    *q++ = ESC_CODE; *q++ = '$'; *q++ = to_kanji_fileio;
+ 	    *q++ = *p++ & 0x7f; *q++ = *p++ & 0x7f;
+ 	    kflag = 1;
+ 	  } else {
+ 	    *q++ = *p++;
+ 	  }
+ 	}
+       }
+       if (kflag) {
+ 	*q++ = ESC_CODE; *q++ = '('; *q++ = to_ascii_fileio;
+       }
+       break;
+     case Shift_JIS:
+       while (p < pend) {
+ 	if (q >= qend) {
+ 	  result = (write(fd, kanji_work_area, (char *)q - kanji_work_area)
+ 		    == (char *)q - kanji_work_area) ? 0 : -1;
+ 	  if (result < 0) break;
+ 	  q = (unsigned char *)kanji_work_area;
+ 	}
+ 	if (JCODEP(p)) {
+ 	  c1 = *p++; c2 = *p++;
+ 	  E2S (c1, c2, *q++, *q++);
+ 	} else {
+ 	  *q++ = *p++;
+ 	}
+       }
+       break;
+     }
+     if (result >= 0) {
+       if (p == pend) *q++ = *p++;
+       result = (write(fd, kanji_work_area, (char *)q - kanji_work_area)
+ 		== (char *)q - kanji_work_area)
+ 		? 0 : -1;
+     }
+   } else
+     result = (write (fd, addr, len) == len) ? 0 : -1;
+ /* end of patch */
+ 
+   if (EQ (bf_cur->selective_display, Qt)) {
+     for (i=0; i<idx; i++) *buf[i] = '\015';
+     free(buf);
+   }
+ 
+   return result;
+ }
+ #else /* not NEMACS */
+ {
    char buf[16 * 1024];
    register char *p, *end;
  
***************
*** 1824,1829 ****
--- 2027,2033 ----
      }
    return 0;
  }
+ #endif /* not NEMACS */
  
  DEFUN ("verify-visited-file-modtime", Fverify_visited_file_modtime,
    Sverify_visited_file_modtime, 1, 1, 0,
***************
*** 2126,2131 ****
--- 2330,2346 ----
    staticpro (&Qfile_error);
    Qfile_already_exists = intern("file-already-exists");
    staticpro (&Qfile_already_exists);
+ 
+ #ifdef NEMACS /* 89.9.1 by S.Tomura*/
+   Qfind_kanji_file_input_code = intern ("find-kanji-file-input-code");
+   staticpro (&Qfind_kanji_file_input_code);
+   Qinvoke_find_kanji_file_input_code = intern ("invoke-find-kanji-file-input-code");
+   staticpro (&Qinvoke_find_kanji_file_input_code);
+   Qfind_kanji_file_output_code = intern ("find-kanji-file-output-code");
+   staticpro (&Qfind_kanji_file_output_code);
+   Qinvoke_find_kanji_file_output_code = intern ("invoke-find-kanji-file-output-code");
+   staticpro (&Qinvoke_find_kanji_file_output_code);
+ #endif
  
    Fput (Qfile_error, Qerror_conditions,
  	Fcons (Qfile_error, Fcons (Qerror, Qnil)));
diff -arcN emacs-18.55/src/indent.c nemacs-3.3.2/src/indent.c
*** emacs-18.55/src/indent.c	Tue Aug 16 11:51:14 1988
--- nemacs-3.3.2/src/indent.c	Wed Jun  6 03:18:37 1990
***************
*** 1,3 ****
--- 1,14 ----
+ /* 87.4.16  modified by K.Handa */
+ /* 87.7.12  modified by K.Handa */
+ /* 87.12.10 modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.5.30  modified for Nemacs Ver.2.1 by K.Handa */
+ /* 89.3.10  modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.9.7   modified for Nemacs Ver.3.2 by K.Handa */
+ /* 89.12.23 modified for Nemacs Ver.3.2.3 by K.Handa
+ 	In compute_motion, fixed a bug of handling truncated lines. */
+ /* 90.4.10  modified for Nemacs Ver.3.3.2 by K.Handa
+ 	Make compatible with original when kanji-flag is off. */
+ 
  /* Indentation functions.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 26,31 ****
--- 37,45 ----
  #include "window.h"
  #include "termchar.h"
  #include "termopts.h"
+ #ifdef NEMACS  /* 88.5.30  by K.Handa */
+ #include "kanji.h"
+ #endif
  
  #define CR '\015'
  
***************
*** 68,73 ****
--- 82,90 ----
    register int post_tab;
    register int tab_width = XINT (bf_cur->tab_width);
    int ctl_arrow = !NULL (bf_cur->ctl_arrow);
+ #ifdef NEMACS  /* 89.3.10  by K.Handa */
+   int kflag = !NULL(bf_cur->kanji_flag);
+ #endif
  
    if (point == last_known_column_point
        && bf_modified == last_known_column_modified)
***************
*** 95,100 ****
--- 112,124 ----
  	{
  	  col++;
  	}
+ #ifdef NEMACS  /* 87.5.1  by K.Handa */
+ /* modified by K.Handa  88.5.30 */
+       else if (kflag && EUC_P(c))
+ 	{
+ 	  col++;
+ 	}
+ #endif  /* NEMACS */
        else if (c == '\n')
  	break;
        else if (c == '\r' && EQ (bf_cur->selective_display, Qt))
***************
*** 232,237 ****
--- 256,264 ----
    register int end = NumCharacters;
    register int tab_width = XINT (bf_cur->tab_width);
    register int ctl_arrow = !NULL (bf_cur->ctl_arrow);
+ #ifdef NEMACS  /* 89.3.10  by K.Handa */
+   int kflag = !NULL(bf_cur->kanji_flag);
+ #endif
  
    Lisp_Object val;
  
***************
*** 260,271 ****
--- 287,305 ----
  	}
        else if (ctl_arrow && (c < 040 || c == 0177))
          col++;
+ #ifndef NEMACS  /* 89.9.7, 90.4.10  by K.Handa */
        else if (c < 040 || c >= 0177)
+ #else
+       else if (c < 040 || (c >= 0177 && !(kflag && EUC_P(c))))
+ #endif
          col += 3;
      }
  
    SetPoint (pos);
  
+ #ifdef NEMACS  /* 87.7.15  by K.Handa */
+   col += point - pos;
+ #endif
    last_known_column = col;
    last_known_column_point = point;
    last_known_column_modified = bf_modified;
***************
*** 307,312 ****
--- 341,349 ----
    register int c;
    register int tab_width = XFASTINT (bf_cur->tab_width);
    register int ctl_arrow = !NULL (bf_cur->ctl_arrow);
+ #ifdef NEMACS  /* 89.3.10  by K.Handa */
+   int kflag = !NULL(bf_cur->kanji_flag);
+ #endif
    int selective
      = XTYPE (bf_cur->selective_display) == Lisp_Int
        ? XINT (bf_cur->selective_display)
***************
*** 320,325 ****
--- 357,372 ----
        c = CharAt (pos);
        if (c >= 040 && c < 0177)
  	cpos++;
+ #ifdef NEMACS  /* 87.5.1  by K.Handa */
+ /* modified by K.Handa  87.7.15 */
+ /* modified by K.Handa  88.5.30, 89.3.10 */
+       else if (kflag && EUC_P(c)
+ 	       && pos < NumCharacters && EUC_P(CharAt(pos+1)))
+ 	{
+ 	  cpos += 2;
+ 	  pos++;
+ 	}
+ #endif  /* NEMACS */
        else if (c == '\t')
  	{
  	  cpos += tab_width
***************
*** 394,399 ****
--- 441,470 ----
  	    }
  
  	}
+ #ifdef NEMACS  /* 87.7.12  by K.Handa */
+ /* 88.5.30, 89.3.10, 89.12.23  modified by K.Handa */
+       else if (kflag
+ 	       && HPOS (cpos) == width - 1
+ 	       && pos < NumCharacters - 1
+ 	       && EUC_P(CharAt (pos+1)) && EUC_P(CharAt (pos+2)))
+ 	{
+ 	  if (cpos >= target)
+ 	    break;
+ 	  if (hscroll
+ 	      || (truncate_partial_width_windows
+ 		  && width + 1 < screen_width)
+ 	      || !NULL (bf_cur->truncate_lines))
+ 	    {
+ 	      while (pos < to && CharAt(pos) != '\n') pos++;
+ 	      pos--;
+ 	    }
+ 	  else
+ 	    {
+ 	      cpos += (1 << SHORTBITS) - (width - 1);
+ 	      tab_offset += (width - 1);
+ 	    }
+ 	}
+ #endif
      }
  
    val_compute_motion.bufpos = pos;
